Reflection mscorlib [00 00 00 00 00 00 00 00 04 00 00 00 00 00 00 00 ] 1.0.5000.0 2.0.0.0 4.0.0.0 System.Enum System.Flags System.Runtime.InteropServices.ComVisible(true)

These BindingFlags control binding for a great many classes in the System, System.Reflection, and System.Runtime namespaces that invoke, create, get, set, and find members and types.

BindingFlags are used in the following methods and other places such as :

InvokeMember and GetMethod are especially important.

The binding flags can be categorized by how they identify a type member, as listed in the following table.

Identified by Accessibility

Identified by Binding Argument

Identified by Operation

You must specify Instance or Static along with Public or NonPublic or no members will be returned.

The following table lists the coercions performed by the default . This table applies especially to the ExactBinding binding flag.

Source Type

Target Type

Any type

Its base type.

Any type

The interface it implements.

Char

UInt16, UInt32, Int32, UInt64, Int64, Single, Double

Byte

Char, UInt16, Int16, UInt32, Int32, UInt64, Int64, Single, Double

SByte

Int16, Int32, Int64, Single, Double

UInt16

UInt32, Int32, UInt64, Int64, Single, Double

Int16

Int32, Int64, Single, Double

UInt32

UInt64, Int64, Single, Double

Int32

Int64, Single, Double

UInt64

Single, Double

Int64

Single, Double

Single

Double

Non-reference

By-reference.

Specifies flags that control binding and the way in which the search for members and types is conducted by reflection.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags CreateInstance To be added.

  Specifies that Reflection should create an instance of the specified type. Calls the constructor that matches the given arguments. The supplied member name is ignored. If the type of lookup is not specified, (Instance | Public) will apply. It is not possible to call a type initializer.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags DeclaredOnly To be added.

  Specifies that only members declared at the level of the supplied type's hierarchy should be considered. Inherited members are not considered.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags Default To be added.

  Specifies no binding flag.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags ExactBinding

  Reflection models the accessibility rules of the common type system. For example, if the caller is in the same assembly, the caller does not need special permissions for internal members. Otherwise, the caller needs . This is consistent with lookup of members that are protected, private, and so on.

  The general principle is that should perform only widening coercions, which never lose data. An example of a widening coercion is coercing a value that is a 32-bit signed integer to a value that is a 64-bit signed integer. This is distinguished from a narrowing coercion, which may lose data. An example of a narrowing coercion is coercing a 64-bit signed integer to a 32-bit signed integer.

  The default binder ignores this flag, while custom binders can implement the semantics of this flag.

  Specifies that types of the supplied arguments must exactly match the types of the corresponding formal parameters. Reflection throws an exception if the caller supplies a non-null Binder object, since that implies that the caller is supplying BindToXXX implementations that will pick the appropriate method.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags FlattenHierarchy To be added.

  Specifies that public and protected static members up the hierarchy should be returned. Private static members in inherited classes are not returned. Static members include fields, methods, events, and properties. Nested types are not returned.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags GetField To be added.

  Specifies that the value of the specified field should be returned.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags GetProperty To be added.

  Specifies that the value of the specified property should be returned.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags IgnoreCase To be added.

  Specifies that the case of the member name should not be considered when binding.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags IgnoreReturn To be added.

  Used in COM interop to specify that the return value of the member can be ignored.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags Instance To be added.

  Specifies that instance members are to be included in the search.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags InvokeMethod To be added.

  Specifies that a method is to be invoked. This must not be a constructor or a type initializer.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags NonPublic To be added.

  Specifies that non-public members are to be included in the search.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags OptionalParamBinding

  Parameters with default values are used only in calls where trailing arguments are omitted. They must be the last arguments.

  Returns the set of members whose parameter count matches the number of supplied arguments. This binding flag is used for methods with parameters that have default values and methods with variable arguments (varargs). This flag should only be used with .

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags Public To be added.

  Specifies that public members are to be included in the search.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags PutDispProperty To be added.

  Specifies that the PROPPUT member on a COM object should be invoked. PROPPUT specifies a property-setting function that uses a value. Use PutDispProperty if a property has both PROPPUT and PROPPUTREF and you need to distinguish which one is called.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags PutRefDispProperty To be added.

  Specifies that the PROPPUTREF member on a COM object should be invoked. PROPPUTREF specifies a property-setting function that uses a reference instead of a value. Use PutRefDispProperty if a property has both PROPPUT and PROPPUTREF and you need to distinguish which one is called.

- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags SetField To be added.

  Specifies that the value of the specified field should be set.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags SetProperty To be added.

  Specifies that the value of the specified property should be set. For COM properties, specifying this binding flag is equivalent to specifying PutDispProperty and PutRefDispProperty.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags Static To be added.

  Specifies that static members are to be included in the search.

  0
- Field
  1.0.5000.0
  2.0.0.0
  4.0.0.0
  System.Reflection.BindingFlags SuppressChangeType To be added.

  Not implemented.

  0
0